//***************************************************************************
// Group Linslot / Linux - Slotrace Manager
// File iointerface.hpp
// Date 16.11.08 - Jrg Wendel
// This code is distributed under the terms and conditions of the
// GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
//***************************************************************************

#ifndef _IO_INTERFACE_H_
#define _IO_INTERFACE_H_

//***************************************************************************
// Include
//***************************************************************************

#include <common.hpp>

//***************************************************************************
// IO Interface
//***************************************************************************

class IoInterface
{
   public:

#     pragma pack(push, 1)

      struct IoValue
      {
         union
         {
            unsigned int dword;
            unsigned char bytes[4];
         };
      };

#     pragma pack(pop)

      // object

      IoInterface();
      virtual ~IoInterface();

      // interface

      virtual int open(const char* dev = 0) = 0;
      virtual int close() = 0;
      virtual int reopen(const char* dev = 0) = 0;
      virtual int isOpen() = 0;
      virtual int flush() = 0;

      // read/write

      virtual int writeBit(int bit, int value) = 0;
      virtual int readOutBit(int bit) = 0;
      virtual int writeByte(unsigned char byte, int byteNum) = 0;
      virtual int readByte(unsigned char* byte, int byteNum) = 0;
      virtual int lookByte(int byteNum, unsigned  char* byte) = 0;

      // settings

      virtual int setTimeout(unsigned int timeout) = 0;
      virtual int setWriteTimeout(unsigned int timeout) = 0;

      timeval getLastIoTime() { timeval tv; gettimeofday(&tv, 0); return tv; }

   protected:

      char deviceName[100+TB];
};

//***************************************************************************
#endif // _IO_INTERFACE_H_
